package com.its.api.its.service.ifsc;

import com.its.api.its.model.dto.ifsc.TbIfscVrtxArrDto;
import com.its.api.its.model.entity.ifsc.TbIfscVrtxArr;
import com.its.api.its.model.entity.ifsc.TbIfscVrtxArrKey;
import com.its.api.its.repository.ifsc.TbIfscVrtxArrRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbIfscVrtxArrService {

    private final TbIfscVrtxArrRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbIfscVrtxArr requireOne(TbIfscVrtxArrKey id) {
        return this.repo.findById(id)
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbIfscVrtxArrDto> findAll() {
        List<TbIfscVrtxArrDto> result = new ArrayList<>();
        List<TbIfscVrtxArr> data = this.repo.findAll();
        for (TbIfscVrtxArr entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbIfscVrtxArrDto findById(TbIfscVrtxArrKey id) {
        TbIfscVrtxArr entity = requireOne(id);
        return entity.toDto();
    }

    /**
     * 레벨에 따른 버텍스 정보 조회
     * @param levl
     * @return
     */
    public List<TbIfscVrtxArrDto> findAllByLevl(Integer levl) {
        List<TbIfscVrtxArrDto> result = new ArrayList<>();
        List<TbIfscVrtxArr> data = this.repo.findAllByLevl(levl);
        data.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }
}
